\"
.\" Standard preamble:
.\" ========================================================================
.de Sh \" Subsection heading
.br
.if t .Sp
.ne 5
.PP
\fB\\$1\fR
.PP
..
.de Sp \" Vertical space (when we can't use .PP)
.if t .sp .5v
.if n .sp
..
.de Vb \" Begin verbatim text
.ft CW
.nf
.ne \\$1
..
.de Ve \" End verbatim text
.ft R
.fi
..
.\" Set up some character translations and predefined strings.  \*(-- will
.\" give an unbreakable dash, \*(PI will give pi, \*(L" will give a left
.\" double quote, and \*(R" will give a right double quote.  \*(C+ will
.\" give a nicer C++.  Capital omega is used to do unbreakable dashes and
.\" therefore won't be available.  \*(C` and \*(C' expand to `' in nroff,
.\" nothing in troff, for use with C<>.
.tr \(*W-
.ds C+ C\v'-.1v'\h'-1p'\s-2+\h'-1p'+\s0\v'.1v'\h'-1p'
.ie n \{\
.    ds -- \(*W-
.    ds PI pi
.    if (\n(.H=4u)&(1m=24u) .ds -- \(*W\h'-12u'\(*W\h'-12u'-\" diablo 10 pitch
.    if (\n(.H=4u)&(1m=20u) .ds -- \(*W\h'-12u'\(*W\h'-8u'-\"  diablo 12 pitch
.    ds L" ""
.    ds R" ""
.    ds C` ""
.    ds C' ""
'br\}
.el\{\
.    ds -- \|\(em\|
.    ds PI \(*p
.    ds L" ``
.    ds R" ''
'br\}
.\"
.\" If the F register is turned on, we'll generate index entries on stderr for
.\" titles (.TH), headers (.SH), subsections (.Sh), items (.Ip), and index
.\" entries marked with X<> in POD.  Of course, you'll have to process the
.\" output yourself in some meaningful fashion.
.if \nF \{\
.    de IX
.    tm Index:\\$1\t\\n%\t"\\$2"
..
.    nr % 0
.    rr F
.\}
.\"
.\" For nroff, turn off justification.  Always turn off hyphenation; it makes
.\" way too many mistakes in technical documents.
.hy 0
.if n .na
.\"
.\" Accent mark definitions (@(#)ms.acc 1.5 88/02/08 SMI; from UCB 4.2).
.\" Fear.  Run.  Save yourself.  No user-serviceable parts.
.    \" fudge factors for nroff and troff
.if n \{\
.    ds #H 0
.    ds #V .8m
.    ds #F .3m
.    ds #[ \f1
.    ds #] \fP
.\}
.if t \{\
.    ds #H ((1u-(\\\\n(.fu%2u))*.13m)
.    ds #V .6m
.    ds #F 0
.    ds #[ \&
.    ds #] \&
.\}
.    \" simple accents for nroff and troff
.if n \{\
.    ds ' \&
.    ds ` \&
.    ds ^ \&
.    ds , \&
.    ds ~ ~
.    ds /
.\}
.if t \{\
.    ds ' \\k:\h'-(\\n(.wu*8/10-\*(#H)'\'\h"|\\n:u"
.    ds ` \\k:\h'-(\\n(.wu*8/10-\*(#H)'\`\h'|\\n:u'
.    ds ^ \\k:\h'-(\\n(.wu*10/11-\*(#H)'^\h'|\\n:u'
.    ds , \\k:\h'-(\\n(.wu*8/10)',\h'|\\n:u'
.    ds ~ \\k:\h'-(\\n(.wu-\*(#H-.1m)'~\h'|\\n:u'
.    ds / \\k:\h'-(\\n(.wu*8/10-\*(#H)'\z\(sl\h'|\\n:u'
.\}
.    \" troff and (daisy-wheel) nroff accents
.ds : \\k:\h'-(\\n(.wu*8/10-\*(#H+.1m+\*(#F)'\v'-\*(#V'\z.\h'.2m+\*(#F'.\h'|\\n:u'\v'\*(#V'
.ds 8 \h'\*(#H'\(*b\h'-\*(#H'
.ds o \\k:\h'-(\\n(.wu+\w'\(de'u-\*(#H)/2u'\v'-.3n'\*(#[\z\(de\v'.3n'\h'|\\n:u'\*(#]
.ds d- \h'\*(#H'\(pd\h'-\w'~'u'\v'-.25m'\f2\(hy\fP\v'.25m'\h'-\*(#H'
.ds D- D\\k:\h'-\w'D'u'\v'-.11m'\z\(hy\v'.11m'\h'|\\n:u'
.ds th \*(#[\v'.3m'\s+1I\s-1\v'-.3m'\h'-(\w'I'u*2/3)'\s-1o\s+1\*(#]
.ds Th \*(#[\s+2I\s-2\h'-\w'I'u*3/5'\v'-.3m'o\v'.3m'\*(#]
.ds ae a\h'-(\w'a'u*4/10)'e
.ds Ae A\h'-(\w'A'u*4/10)'E
.    \" corrections for vroff
.if v .ds ~ \\k:\h'-(\\n(.wu*9/10-\*(#H)'\s-2\u~\d\s+2\h'|\\n:u'
.if v .ds ^ \\k:\h'-(\\n(.wu*10/11-\*(#H)'\v'-.4m'^\v'.4m'\h'|\\n:u'
.    \" for low resolution devices (crt and lpr)
.if \n(.H>23 .if \n(.V>19 \
\{\
.    ds : e
.    ds 8 ss
.    ds o a
.    ds d- d\h'-1'\(ga
.    ds D- D\h'-1'\(hy
.    ds th \o'bp'
.    ds Th \o'LP'
.    ds ae ae
.    ds Ae AE
.\}
.rm #[ #] #H #V #F C
.\" ========================================================================
.\"
.TH python-spf 1 "2012-02-05"
.SH "NAME"
pyspf \- pure-Python SPF library
.SH "VERSION"
2\.0\.9

.SH "DESCRIPTION"

SPF does email sender validation.  For more information about SPF,
please see http://www.openspf.org/

One incompatible change was introduced in version 1.7.  Prior to version 1.7,
connections from a local IP address (127...) would always return a Pass 
result.  The special case was eliminated.  Programs calling pySPF should not
do SPF checks on locally submitted mail.

This SPF client is intended to be installed on the border MTA, checking
if incoming SMTP clients are permitted to forward mail.  The SPF check
should be done during the MAIL FROM:<...> command.

.SH "USAGE"

There are multiple ways to use this package:

    To check an incoming mail request:
        % pyspf [\-v] {ip} {sender} {helo}
        % pyspf 69.55.226.139 tway@optsw.com mx1.wayforward.net

    To test an SPF record:
        % pyspf [\-v] "v=spf1..." {ip} {sender} {helo}
        % pyspf "v=spf1 +mx +ip4:10.0.0.1 \-all" 10.0.0.1 tway@foo.com a    

    To fetch an SPF record:
        % pyspf {domain}
        % pyspf wayforward.net

    To test this script (and to output this usage message):
        % pyspf

For instance, during an SMTP exchange from client 69.55.226.139::
        S: 220 mail.example.com ESMTP Postfix
        C: EHLO mx1.wayforward.net
        S: 250-mail.example.com
        S: ...
        S: 250 8BITMIME
        C: MAIL FROM:<terry@wayforward.net>

Then the following command line would check if this is a valid sender:
        % pyspf 69.55.226.139 terry@wayforward.net mx1.wayforward.net
        ('pass', 250, 'sender SPF authorized')

Command line calls return RFC 4408 result codes, i.e. 'pass', 'fail', 'neutral', 
\'softfail, 'permerror', or 'temperror'.

.SH "RFC 4408/7208 TEST SUITE"

The package also installs the python-spf test driver and the current (as of the
release date) YAML (Yet Another Markup Language) RFC 4408/7208 test
definitions.  As errors or improvements in the test definitions are approved,
they are available from:

<http://www.openspf.net/Test_Suite>

To run the test suite, change the directory the test suite is installed in:

$ cd /usr/share/doc/python-spf

Uncompress testspf.py.gz, testspf.py.gz, and rfc4408-tests.yml.gz

and then run testspf.py:

$ python testspf.py (also works with python3)

The test suite supports multiple allowed results with a warning for a 
non-preferred result.  For the current version, the expected results are:

WARN: spfonly in rfc4408-tests.yml, 4.4/1: fail preferred to none
WARN: invalid-domain-long in rfc4408-tests.yml, ['4.3/1', '5/10/3']: permerror preferred to fail
WARN: txttimeout in rfc4408-tests.yml, 4.4/1: fail preferred to temperror
WARN: invalid-domain-empty-label in rfc4408-tests.yml, ['4.3/1', '5/10/3']: permerror preferred to fail
WARN: exists-dnserr in rfc4408-tests.yml, 5.7/3: fail preferred to temperror
WARN: spfoverride in rfc4408-tests.yml, 4.5/5: pass preferred to fail
WARN: multitxt1 in rfc4408-tests.yml, 4.5/5: pass preferred to permerror
WARN: mx-limit in rfc4408-tests.yml, 10.1/7: neutral preferred to permerror
WARN: multispf2 in rfc4408-tests.yml, 4.5/6: permerror preferred to pass
WARN: invalid-domain-long-via-macro in rfc4408-tests.yml, ['4.3/1', '5/10/3']: permerror preferred to fail

Due to the resolution of a number of ambiguities in the SPF specification in
RFC 7208, there should be no warnings for the RFC 7208 portions of the test
suite.

.SH "SEE ALSO"

RFC 7208, <http://www.openspf.org>

.SH "AUTHORS"
This version of \fBpyspf\fR was written by Terence Way <terry-spf@wayforward.net>
and updated by Stuart Gathman <stuart@bmsi.com> and Scott Kitterman 
<scott@kitterman.com>.
.PP
This man-page was created by Scott Kitterman <scott@kitterman.com>.
